/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.common;

import jp.getset.gae.bigtable.Conncetion;
import jp.getset.gae.driver.java.sql.Connection;
import java.sql.SQLException;

import jp.getset.gae.driver.javax.naming.NamingException;

/**
 * DBとの接続を管理する。
 */
public abstract class DBConnBean {
	
	/**
	 * DBコネクション。<br>
	 * {@link #getConnection(String, String, String, String)}
	 * により、設定される。
	 */
	protected Connection conn;
	
	/**
	 * コンストラクタ。
	 */
	protected DBConnBean() {
		conn = null;
	}
	
	/**
	 * DBコネクションを取得する。<br>
	 * JDBCを用いてDBコネクションを取得し、
	 * {@link #conn}に割当てる。<br>
	 * 取得したコネクションはAutoCommit機能を利用しない。<br>
	 * @param RDBDRIVER JDBC名
	 * @param RDBNAME DBのURL
	 * @param USERID DB接続ユーザーID
	 * @param PASSWORD パスワード
	 * @throws ClassNotFoundException
	 * @throws SQLException
	 */
	protected void getConnection(
			String RDBDRIVER,
			String RDBNAME  ,
			String USERID   ,
			String PASSWORD
	) throws ClassNotFoundException, SQLException {
		conn = new Conncetion();
	}
	
	/**
	 * DBコネクションを取得する。<br>
	 * DataSourceを用いてDBコネクションを取得し、
	 * {@link #conn}に割当てる。<br>
	 * 取得したコネクションはAutoCommit機能を利用しない。<br>
	 * @param DATASOURCE データソース名
	 * @throws NamingException 
	 * @throws SQLException 
	 */
	protected void getConnection(
			String DATASOURCE
	) throws NamingException, SQLException {
		conn = new Conncetion();
	}
	
	/**
	 * DBコネクションを開放する。<br>
	 * {@link #conn}を開放する。
	 * @throws SQLException
	 */
	protected void releaseConnection() throws SQLException {
		if (conn != null && !conn.isClosed()) {
			conn.close();
		}
		if (conn != null) {
			conn = null;
		}
	}
	
	
	/**
	 * トランザクションをコミットする。<br>
	 * {@link #conn}のトランザクションをコミットする。
	 * @throws SQLException
	 */
	protected void commit() throws SQLException {
		if (conn != null && !conn.isClosed()) {
			conn.commit();
		}
	}
	
	
	/**
	 * トランザクションをロールバックする。<br>
	 * {@link #conn}のトランザクションをロールバックする。
	 * @throws SQLException
	 */
	protected void rollback() throws SQLException {
		if (conn != null && !conn.isClosed()) {
			conn.rollback();
		}
	}
	
}
